/* $Id: CerdispS.h,v 1.3 2002/08/09 01:44:12 d Exp $ */
/* David Leonard, 2002. Public domain. */

#ifndef _CerdispS_h
#define _CerdispS_h

/*
 * Structures used reading the CERDISP protocol
 */

struct preamble {
	u_int32_t       magic;
	u_int32_t       width;
	u_int32_t       height;
	u_int32_t       depth;
	u_int32_t       unk1;
	u_int32_t       unk2;
	char            platform[128];
	char            devtype[128];
	char            name[16];
	u_int32_t       unk3;
};

struct palettehdr {
	u_int32_t	type;		/* always 1? */
	u_int32_t	datalen;
};

struct palette {
	u_int8_t	red;		/* ? unsure */
	u_int8_t	green;		/* ? unsure */
	u_int8_t	blue;		/* ? unsure */
	u_int8_t	x;		/* ? unsure */
};

struct framehdr {
	u_int32_t       unk0;
	u_int32_t       datalen;
	u_int32_t       unk1;
	u_int32_t       unk2;
	u_int32_t       width;
	u_int32_t       height;
} framehdr;

struct rle {
	u_int16_t	repeat;
	union {
	    struct {
#if X_BYTE_ORDER == X_LITTLE_ENDIAN
		u_int16_t	blue : 5;
		u_int16_t	x : 1;
		u_int16_t	green : 5;
		u_int16_t	red : 5;
#else /* X_BIG_ENDIAN */
		u_int16_t	red : 5;
		u_int16_t	green : 5;
		u_int16_t	x : 1;
		u_int16_t	blue : 5;
#endif /* X_BIG_ENDIAN */
	    } col;
	    struct {
#if X_BYTE_ORDER == X_LITTLE_ENDIAN
		u_int16_t	p1 : 4;	/* palette index of second pixel */
		u_int16_t	p0 : 4;	/* first pixel */
		u_int16_t	p3 : 4; /* fourth pixel */
		u_int16_t	p2 : 4; /* third pixel */
#else /* X_BIG_ENDIAN */
		u_int16_t	p2 : 4;
		u_int16_t	p3 : 4;
		u_int16_t	p0 : 4;
		u_int16_t	p1 : 4;
#endif /* X_BIG_ENDIAN */
	    } col4;
	    u_int16_t word;
	} u;
};

#endif /* _CerdispS_h */
