.\" $Id: xcerdisp.man,v 1.11 2002/08/10 14:20:46 d Exp $
.\" David Leonard, 2001. Public domain.
.TH XCERDISP 1
.SH NAME
xcerdisp \- Microsoft Windows CE remote control tool
.SH SYNOPSIS
.B xcerdisp
[\-toolkitoption ... ]
.SH DESCRIPTION
.I Xcerdisp
displays the screen of a Windows CE handheld in an X window and accepts user
input with the pointer and keyboard.
It communicates with the Microsoft Windows Remote Display Control
application that runs natively under Windows CE.
.PP
.I Xcerdisp
listens on privileged TCP port 987, which usually requires superuser
privileges.
.SH OPTIONS
.I Xcerdisp
accepts all of the standard X Toolkit command line
options, as well as the following:
.TP 8
.B \-version
print the version number on the standard error
.TP 8
.BI \-port " port"
set the port to listen on for connections from the client
.TP 8
.BI \-proxy " host"
proxy the client connection onto the server at
.I host
.TP 8
.BI \-proxyport " port"
the server port to use when proxying the client connection (defaults to 987)
.TP 8
.B \-verbose
send informational messages to the standard error
.TP 8
.BI \-scale " factor"
scale the window by the given factor.
For example a factor of 2 doubles the width and height.
Defaults to 1.
.SH PROXY CHAINS
.I Xcerdisp
can be configured to act as a proxy, where it also relays the
control channel to other instances of itself, or to the original Microsoft
Windows desktop tool. This is done by setting the proxy resource to
the IP address of the host running the other remote control tool.
This is useful for replicating the display of the handheld onto multiple
desktops.
.SH "RESOURCES"
The following resources are specified as part of the \fIcerdisp\fP widget (class
\fICerdisp\fP):
.\".in +1in
.TP 8
.B "listenPort (\fPclass\fB ListenPort)"
The TCP port number on which to listen for client connections.
The default is 987.
.TP 8
.B "proxy (\fPclass\fB Proxy)"
The IP address of the host to which to forward a copy of the connection.
The default is NULL (indicating no proxy chaining).
.TP 8
.B "proxyPort (\fPclass\fB ProxyPort)"
The TCP port number of the server to which to forward a copy of
the connection.
The default is 987.
.TP 8
.B "printVersion (\fPclass\fB PrintVersion)"
Whether or not to print the version number when initialising.
The default is false.
.TP 8
.B "verbose (\fPclass\fB Verbose)"
Whether or not to send informational messages to the standard error.
The default is false.
.TP 8
.B "scale (\fPclass\fB Scale)"
Display scaling factor; an integer greater than zero.
Defaults to 1.
.SH "ACTIONS"
It is possible to rebind keys to perform different actions, through
the \fItranslations\fP resource. 
The following actions are provided:
.TP 8
.B "scale(\fIs\fB)"
This action changes the scale resource. If \fIs\fP starts with + or -
then it is treated as an increment to be applied to the current scale.
Otherwise it is treated as an integer scale to apply.
.TP 8
.B "input()"
With no arguments, this action sends the current key or pointer event
to the remote device.
.TP 8
.B "input(\fIkeyevent\fB, \fIvalue\fB)"
This action sends the described key event to the device.
The \fIkeyevent\fP parameter must be either \fBKeyDown\fP or \fBKeyUp\fP.
The \fIvalue\fP parameter is the device encoding of the key (not ASCII).
.TP 8
.B "input(\fIbuttonevent\fB, \fIx\fB, \fIy\fB)"
This action sends the described pointer event to the device.
The \fIbuttonevent\fP parameter is one of \fBBtnDown\fP, \fBBtnUp\fP
or \fBMotion\fP.
The remaining arguments are coordinates in the device display.
.TP 8
.B "close()"
This action closes the connection to the remote device.
.PP
The default translations for the Cerdisp widget are:
.sp
.in +4
.DS
.TA 2.5i
.ta 2.5i
.nf
!Shift <Key>KP_Add:             scale(+1) \\n\\
!Shift <Key>KP_Subtract:        scale(-1) \\n\\
<KeyDown>:                      input()   \\n\\
<KeyUp>:                        input()   \\n\\
<Btn1Down>:                     input()   \\n\\
<Btn1Motion>:                   input()   \\n\\
<Btn1Up>:                       input()
.fi
.DE
.sp
.in -4
.PP
.SH "SEE ALSO"
http://www.microsoft.com/mobile/pocketpc/downloads/powertoys.asp,
http://synce.sourceforge.net/,
X(1), X Toolkit documentation
.SH AUTHOR
David Leonard, ITEE, University of Queensland, Australia
